/*_____________________________________________________________________________________________________________________________________________________________________
SNS_TABLE_OBJECT.mqh SNS_ObjectLibrary.mqhSteven N. Scott

NOTE: THIS IS AN #INCLUDE FILE AND (DUE TO A QUIRK IN MQL4) NEEDS TO BE IN BOTH YOUR EXPERT\LIBRARIES AND YOUR EXPERT\INDICATORS FOLDERS.
_______________________________________________________________________________________________________________________________________________________________________*/
#property copyright "Steven N. Scott"
#property link      ""

// IMPORT LIBRARY OF SNSCOTT'S COMMON FUNCTIONS AND UTILITIES============================================================================================================
// v2.0

#import "SNS_ObjectLibrary.ex4"

	// GENRERAL UTILITIES-------------------------------------------------------------------------------------------------------------------------------------------------
	string	SNSLibraryVersion();
	void 		SNSTAG();
	void 		DeleteObjectsByPrefix(string Prefix);
	bool   	IsMini();
	bool   	IsDoubleDotted();
	bool   	IsDotted();	

	// GRAPHIC OBJECT UTILITIES-------------------------------------------------------------------------------------------------------------------------------------------
   void 		Draw_HLine(string prefix, string name, int style, int width, color clr, datetime x, double y, bool back, int window=0);
   void 		Draw_VLine(string prefix, string name, int style, int width, color clr, datetime x,  bool back, int window=0);
   void 		Draw_TLine(string prefix, string name, int style, int width, color clr, datetime x1, double y1, datetime x2, double y2, bool ray, bool back, int window=0);
	void 		Draw_LabeledLine(string prefix, string name, int style, int width, color clr, datetime x1, double y1, datetime x2, double y2, bool ray, string label, string font, int fontsize, color fontcolor,datetime labelx, double labely, int window=0);
	void 		Draw_Box(string prefix, string name, color boxcolor, datetime x1, double y1, datetime x2, double y2, bool back, int linewidth, int linestyle, int window=0);
   void 		Draw_Fibo(string prefix, string name, int style, int width, color fibcolor, int levelstyle, int levelwidth, color levelcolor,  datetime x1, double y1, datetime x2, double y2, bool ray, bool back, int window=0);
	void 		Draw_FiboChannel(string prefix, string name, int style, int width, color fibcolor, int levelstyle, int levelwidth, color levelcolor,  datetime x1, double y1, datetime x2, double y2, datetime x3, double y3, bool ray, bool back, int window=0);
   void 		Draw_Text(string prefix, string name, string text, datetime x, double y, string font, int fontsize, color fontcolor, bool back, int window=0);
   void 		Draw_VText(string prefix, string name, string text, datetime x, double y, string font, int fontsize, color fontcolor, bool back, int window=0);
   void 		Draw_Label(string prefix, string name, string text, int corner, int x, int y, string font, int fontsize, color fontcolor, bool back, int window=0);
   void 		Draw_Symbol(string prefix, string name, int code, color colour, datetime x, double y, int size, bool back, int window=0);
   void 		Draw_Arrow(string prefix, string name, string dir, color colour, datetime x, double y, int size, bool back, int window=0);
   void 		Draw_PriceBox(string prefix, string name, bool left, int width, color colour, datetime x, double y, bool back, int window=0);
   
   // TIME UTILITIES----------------------------------------------------------------------------------------------------------------------------------------------------
	datetime TimeAddPeriod(datetime dt, int period, int inc);
	datetime TimeAddMinutes(datetime dt, int minutes);
	datetime TimeAddHours(datetime dt, int hours);
	datetime TimeAddDays(datetime dt, int days);
	datetime TimeAdd(datetime dt, int inc);

	string 	TimeMDYHMSToStr(int nYear,int nMonth,int nDay,int nHour,int nMin,int nSec);
	string 	TimeDateTimeToStr(datetime dt); 
	string	TimeToFormatStr(datetime dt, string format);	
	string 	TimeTFToString(int tf);
	string 	TimeFrameUnit(int tf);
	int 		TimeEncompassing(string tf);
	string	TimeDOW(int d);
	
	// STRING UTILITIES-------------------------------------------------------------------------------------------------------------------------------------------------
	int 		StringToTimeFrame(string tf);
	string 	StringRepeat(string str, int n);
	string 	StringUpperCase(string str);
	string 	StringLowerCase(string str);
	string 	StringLeftPad(string str, int n, string str2);
	string 	StringRightPad(string str, int n, string str2);
	string 	StringLeft(string str, int n);
	string 	StringRight(string str, int n);
	int 		StringToArray(string& array[], string source);
	int 		StringToUCArray(string& array[], string source);
	int 		StringToLCArray(string& array[], string source);
	int 		StringToIntArray(int& array[],string source);
	int 		StringToDoubleArray(double& array[],string source);
	string 	StringTrim(string str);		
	string 	StringRightAlign( string rString, int ra );
	int 		StringToColor(string str);
	string 	PriceAbrvToName(string p);
	string 	PriceAbrv(string p);
	
	// OBJECT UTILITIES-----------------------------------------------------------------------------------------------------------------------------------------------
	string 	ObjectUniqueName(string prefix, string rest);

	// REVERSAL UTILITIES-----------------------------------------------------------------------------------------------------------------------------------------------
	color		RevGetColor(color defaultColor, bool SetIfMissing);
	color		RevSetColor(color RevColor);
	bool 		RevColorChanged(color PreviousColor);
	int 		RevStatus(string myPair, int TimeFrame, double Threshold, bool ShortTrader, bool LongTrader );
	
#import
///\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\

